// Agent.h: interface for the CAgent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AGENT_H__54C9293A_1E4D_4F88_A03D_BFD9C3FB499A__INCLUDED_)
#define AFX_AGENT_H__54C9293A_1E4D_4F88_A03D_BFD9C3FB499A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Strategy.h"

class CStrategySpace;

class CAgent  
{
public:
	int pred(int mu);
	void spoints_update(int mu, int win);

	CAgent(int q, int m, int T, double tau, long *idum);
	CAgent(int q, int T, double tau, CStrategySpace *psspace, long *idum);
	virtual ~CAgent();

protected:
	int bastrat();
	double m_dThres;		//threshold value
	int m_iT;				//time horizon
	double m_dTau;			//confidence level
	int m_iQ;				//number of strategies
	int m_iM;				
	CStrategy **m_pStrats;	//array of pointers to strategies
	long *m_pidum;			//pointer to random number seed
	int *work;				//temp array

	//declarations for strategy space implementation
	bool m_bSSpace;
	CStrategySpace * m_pSSpace;
	int *m_iStrats;
};

#endif // !defined(AFX_AGENT_H__54C9293A_1E4D_4F88_A03D_BFD9C3FB499A__INCLUDED_)
