// BitArray.h: interface for the CBitArray class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BITARRAY_H__1EF47C97_D3B9_4044_A61F_7E24BC39A30C__INCLUDED_)
#define AFX_BITARRAY_H__1EF47C97_D3B9_4044_A61F_7E24BC39A30C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <iostream.h>

class CBitArray  
{
public:
	CBitArray(int Size = 320);
	virtual ~CBitArray();

	void ClearAllBits();
	void SetBit(int i);
	void ClearBit(int i);
	int GetBit(int i) const;
	int NumItems() const { return N; }

   //***************************************************************
   // private data
   //***************************************************************
private:

   int *TheArray;    //The bit array
   int N;            //Number of bits
   int ArraySize;    //Size fo the array

   enum { IntSz = sizeof(int) * 8 };

   //***************************************************************
   // private check range function
   //***************************************************************
   int IsInRange(int i) const;

   //***************************************************************
   //Disable operator= and copy constructor
   //***************************************************************
   const CBitArray & operator= (const CBitArray & Rhs );
   CBitArray( const CBitArray & Rhs );


};

#endif // !defined(AFX_BITARRAY_H__1EF47C97_D3B9_4044_A61F_7E24BC39A30C__INCLUDED_)
