// DrDobb.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <string.h>
#include <time.h>
#include <iostream.h>


//
// Implementation of simple generic complex system
//
// David Lamper : lamper@maths.ox.ac.uk
// Neil F. Johnson : n.johnson@physics.ox.ac.uk
//


int main(int argc, char* argv[])
{
	long idum;	
	int seed, wait, iter;

	//game parameters
	int N=151;					//# of agents
	int m = 3;					//length of history bit-string studied by agents
	int q = 4;					//# strategies per agent
	int T = 60;					//time horizon
	double tau = 0.54;			//threshold probability
	double phi = 0.53;			//resource level, where L(t) = phi * V(t)

	idum=time(NULL);			//seed random number generator

	//Timesteps:
	seed=T+m;			
	wait=1000;
	iter=4000;

	char run_no[10]="200";		//used to generate filename
	
	char root_dataout[20]="data";
	char data_extension[]=".txt";

	//concatenate strings to form file names
	strcat(run_no,data_extension);
	strcat(root_dataout,run_no);

	//create game object
	CGame mygame(seed, wait, iter, N, m, q, T, tau, phi, &idum);

	//run game
	mygame.go();

	//writeout data
	mygame.dataout(root_dataout);
	
	cout << "\nFinished!! bye ... \n\n";

	return 0;
}


