// Game.h: interface for the CGame class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAME_H__49D6547E_7E0D_4A2B_B1B2_3045F34131FD__INCLUDED_)
#define AFX_GAME_H__49D6547E_7E0D_4A2B_B1B2_3045F34131FD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Agent.h"

class CStrategySpace;

class CGame  
{
public:
	int go();
	int dataout(const char *OutFile);
		
	CGame(int seed, int wait, int iter, int N, int m, int q, int T, double tau, double phi, long *idum);
	virtual ~CGame();

protected:
	int priceupdate(int demand, int price);
	int hist();
	const int bhist2dec(int i, int m);
	long *m_pidum;

	int m_iSeed;
	int m_iWait;
	int m_iIter;
	int m_iStep;			//what iteration number are we on?
	int m_iWin;				//the winning option
	
	int m_iN;				//game parameters
	double m_iPhi;
	int m_iM;
	int m_iT;
	double m_iTau;
	int m_iQ;
	CAgent **m_pAgents;		//array of pointers to agents

	int** m_aOutput;
	int m_Hist[2];

	bool m_bSSpace;
	CStrategySpace *m_pSSpace;
};

#endif // !defined(AFX_GAME_H__49D6547E_7E0D_4A2B_B1B2_3045F34131FD__INCLUDED_)
