// DataPoint.h : Declaration of the CDataPoint
//
// Copyright (c) 2002 Silicon Energy Corp.  All rights reserved.
// This code may be freely distributed and used in commercial or non-commercial
// applications.  However, it must be accompanied by the above copyright notice
// and this comment block.
//
// Revision History:
// WHO				WHEN				WHAT
// Bob Gunion		April 2002			Created
//

#pragma once
#include "resource.h"       // main symbols

#include "SiEDataPoints_Unmanaged.h"


// CDataPoint

class ATL_NO_VTABLE CDataPoint : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CDataPoint, &CLSID_DataPoint>,
	public IDispatchImpl<IDataPoint, &__uuidof(IDataPoint), &LIBID_SiEDataPointInterfacesLib, /* wMajor = */ 1, /* wMinor = */ 0>
{
public:
	CDataPoint()
	{
	}

	DECLARE_REGISTRY_RESOURCEID(IDR_DATAPOINT)


	BEGIN_COM_MAP(CDataPoint)
		COM_INTERFACE_ENTRY(IDispatch)
		COM_INTERFACE_ENTRY(IDataPoint)
	END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease() 
	{
	}

	// IDataPoint Methods
public:
	STDMETHOD(get_ID)(long * pVal);
	STDMETHOD(put_ID)(long pVal);
	STDMETHOD(get_Name)(BSTR * pVal);
	STDMETHOD(put_Name)(BSTR pVal);
	STDMETHOD(get_Channel)(long * pVal);
	STDMETHOD(put_Channel)(long pVal);

private:
	LONG					m_lID;
	CComBSTR				m_bstrName;
	LONG					m_lChannel;
};

OBJECT_ENTRY_AUTO(__uuidof(DataPoint), CDataPoint)
