using System;
using System.Runtime.InteropServices;

namespace Testit_CSharp
{
	/// <summary>
	/// Summary description for StopWatch.
	/// </summary>
	internal class StopWatch
	{
		[DllImport("kernel32.dll")]
		static extern void QueryPerformanceFrequency(out long perfFrequency);

		[DllImport("kernel32.dll")]
		static extern void QueryPerformanceCounter(out long perfCounter);

		private long				m_lPerfFrequency;
		private long				m_lStart;
		private DateTime			m_dtStart;

		public StopWatch()
		{
			QueryPerformanceFrequency(out m_lPerfFrequency);
			m_dtStart = DateTime.Now;
			QueryPerformanceCounter(out m_lStart);
		}

		public double Stop()
		{
			long lStop;
			QueryPerformanceCounter(out lStop);
			DateTime dtStop = DateTime.Now;
			// Use low-resolution time for anything > 10 seconds
			if ( (dtStop.Ticks - m_dtStart.Ticks) > 1e8)
				return ((double)(dtStop.Ticks - m_dtStart.Ticks) * 1e-7);
			// Use high-resolution time for anything <= 10 seconds
			return ((double)(lStop - m_lStart))/((double)m_lPerfFrequency);
		}

		public void Reset()
		{
			m_dtStart = DateTime.Now;
			QueryPerformanceCounter(out m_lStart);
		}
	}
}
