// Strategy.cpp: implementation of the CStrategy class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Strategy.h"

#include "BitArray.h"

#include <iostream.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

//Default Constructor
CStrategy::CStrategy(int m, int T, long *idum)
{
	int i;
	
	//Store values
	m_iM = m;
	m_iT = T;
	m_pidum=idum;
	
	m_iS=0;
	m_iSindex=0;
	
	//Create array to store strategy
	int hist_size = (int)pow(2,m_iM);	//possibly pass this one in ..?

	m_Strategy = new CBitArray(hist_size);

	for(i=0;i<hist_size;i++)			//create strategy
		if(ran2(m_pidum)>0.5)
			m_Strategy->SetBit(i);	

	//Points bit array
	m_Points = new CBitArray(m_iT);
	
}


CStrategy::~CStrategy()
{
	//are the bit arrays deleted at this stage?
	delete [] m_Points;
}


//////////////////////////////////////////////////////////////////////
// Strategy
//////////////////////////////////////////////////////////////////////

//return the number of points
const int CStrategy::points()
{
	return m_iS;
}

//return strategy prediciton based on the current history mu
const int CStrategy::pred(int mu)
{
	return m_Strategy->GetBit(mu);
}

//update the strategy point score
void CStrategy::points_update(int mu, int win)
{
	int Si;
	const int prediction = pred(mu);			//strategy prediction

	if(win==prediction)
		Si = 1;
	else
		Si = 0;

	m_iS += Si - m_Points->GetBit(m_iSindex);	//# strategy points

	if(Si==1)
		m_Points->SetBit(m_iSindex);
	else
		m_Points->ClearBit(m_iSindex);

	if( ++m_iSindex == m_iT)					//update index
		m_iSindex=0;

	return;
}



