// Strategy.h: interface for the CStrategy class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STRATEGY_H__526F3331_052D_4B60_913E_D71C626FC8CA__INCLUDED_)
#define AFX_STRATEGY_H__526F3331_052D_4B60_913E_D71C626FC8CA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


//forward declaration
class CBitArray;

class CStrategy  
{
public:
	const int points();
	const int pred(int mu);		
	void points_update(int mu, int win);
	
	CStrategy(int m, int T, long *idum);
	virtual ~CStrategy();

protected:

	int m_iM;				//History length M
	int m_iT;				//Time horizon T
	int m_iSindex;			//Index into the virtual points array
	int m_iS;				//# Virtual points 
	int m_iPred;			//Current prediction

	long *m_pidum;			//Pointer to random number seed
	
	CBitArray *m_Strategy;  //Pointer to strategy bit array
	CBitArray *m_Points;    //Pointer to points bit array
	

};

#endif // !defined(AFX_STRATEGY_H__526F3331_052D_4B60_913E_D71C626FC8CA__INCLUDED_)
