#define SERVO_FIFO 16

pthread_t thread[2];
int fd[2], fd_par;

int init_module(void)
{
	int i;
	char file[256];

	/* open the fifo's */
	for ( i = 0; i < 2; i++ )
	{
		sprintf( file, "/dev/rtf%d",
			 SERVO_FIFO+i );
		if ( (fd[i] = open(file, O_RDONLY | O_CREAT |
				   O_NONBLOCK) ) < 0 )
		{
			rtl_printf("Could not open %s\n", file);
			return -1;
		}
	}

	/* create FIFO handlers */
	for ( i = 0; i < 2; i++ )
		rtf_create_handler(SERVO_FIFO+i, fifo_handler);

	/* open the parallel port device */
	if ( (fd_par = open("/dev/lpt0",
			    O_NONBLOCK)) < 0 )
	{
		rtl_printf("Could not open /dev/lpt0\n");
		return -1;
	}
	
	/* create the tasks */
	for ( i = 0; i < 2 ; i++ )
	{
		if ( pthread_create( &thread[i], NULL,
				     thread_code, (void *)i ) )
			rtl_printf("thread %d failed create\n",
				   i);
	}
	
	return 0;
}
