unsigned long frame_length = 20000000;

void *thread_code(void *t)
{
	struct timespec next;
	int num = (int)t;

	clock_gettime( CLOCK_REALTIME, &next );

	for (;;)
	{
		/* turn on the pulse */
		ioctl(fd_par, RTL_PAR_SETBIT, num);

		/* setup for the idle part of the duty cycle */
		timespec_add_ns( &next, pulse_length[num] );
		clock_nanosleep( CLOCK_REALTIME,
				 TIMER_ABSTIME, &next, NULL);
		
		/* turn off the pulse */
		ioctl(fd_par, RTL_PAR_CLEARBIT, num);
		
		/* setup for the next pulse */
		timespec_add_ns( &next,
				 frame_length - pulse_length[num] );
		clock_nanosleep( CLOCK_REALTIME,
				 TIMER_ABSTIME, &next, NULL);
	}
}

